<?php

/*
  Plugin Name: AFS Analytics Partner Information
  Description: A module to easily set your AFS Analytics Partner ID
  Version: 1.0.0
  Author: AFS Analytics
  Author URI: https://www.analytics.com/
  Text Domain: afsa_partners
  Domain Path: /languages
 */




defined('ABSPATH') || exit;


/* option group id  */
define('AFSA_PARTNERS_OPTIONS_GROUP', 'afsa_partners_plugin');


/* setting page menu id */
define('AFSA_PARTNERS_SETTING_PAGE_ID', 'afsa_partners_settings_page');

/* id of the main setting section  */
define('AFSA_PARTNERS_SETTINGS_MAIN_SECTION_ID', 'afsa_partners_settings_main_section');


/* saved array containing partner info */
define('AFSA_PARTNERS_OPTIONS_NAME', 'afsa_paa_rc');

/* partner id setting name */
define('AFSA_PARTNERS_SETTING_PARTNER_ID', 'id');



if (!class_exists('AFSA_Partners_Plugin')) :

    class AFSA_Partners_Plugin {

        private $title;

        public function __construct() {

            add_action('admin_menu', array($this, 'add_settings_page'));
            add_action('admin_init', array($this, 'register_settings'));
            $this->title = __('AFS Analytics Partner Program', 'afsa_partners');
        }

        function add_settings_page() {



            add_options_page(
                    $this->title,
                    $this->title,
                    'manage_options',
                    AFSA_PARTNERS_SETTING_PAGE_ID,
                    array($this, 'render_options_page') // Callback
            );
        }

        function register_settings() {

            register_setting(
                    AFSA_PARTNERS_OPTIONS_GROUP,
                    AFSA_PARTNERS_OPTIONS_NAME
            );

            add_settings_section(
                    AFSA_PARTNERS_SETTINGS_MAIN_SECTION_ID,
                    __('Partner Information', 'afsa_partners'),
                    array($this, 'render_section'), // callback
                    AFSA_PARTNERS_OPTIONS_GROUP
            );

            add_settings_field(
                    AFSA_PARTNERS_SETTING_PARTNER_ID,
                    __('Partner ID', 'afsa_partners'),
                    array($this, 'render_partner_id'), // callback
                    AFSA_PARTNERS_OPTIONS_GROUP,
                    AFSA_PARTNERS_SETTINGS_MAIN_SECTION_ID
            );
        }

        // RENDERING       

        function render_partner_id() {

            $options = get_option(AFSA_PARTNERS_OPTIONS_NAME);
            $value = empty($options[AFSA_PARTNERS_SETTING_PARTNER_ID]) ?
                    '' :
                    $options[AFSA_PARTNERS_SETTING_PARTNER_ID];


            print '<input type="text" '
                    . ' name="' . AFSA_PARTNERS_OPTIONS_NAME . '[' . AFSA_PARTNERS_SETTING_PARTNER_ID . ']"'
                    . ' value="' . $value . '">'
            ;
        }

        function render_section() {
            // print __('', 'afsa_partners');
            return '';
        }

        function render_options_page() {

            print
                    '<form action="options.php" method="post">'
                    . '<h2>' . $this->title . '</h2>'
            ;

            settings_fields(AFSA_PARTNERS_OPTIONS_GROUP);
            do_settings_sections(AFSA_PARTNERS_OPTIONS_GROUP);
            submit_button();


            print '</form>';
        }

    }

    $afsa_partners_plugin = new AFSA_Partners_Plugin();




endif;
